<?php
/*
 * Copyright(c) 2015 PAYDESIGN, Inc. All rights reserved.
 * http://www.paydesign.co.jp/
 */

namespace DoctrineMigrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20151201124500 extends AbstractMigration {

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema) {

        // this up() migration is auto-generated, please modify it to your needs
        $this->createPlgPayDesignPlugin($schema);
        $this->createPlgPayDesignPaymentMethod($schema);
        $this->createPlgPayDesignProductPeriodicInfo($schema);
        $this->createPlgPayDesignOrderInfo($schema);
        $this->createPlgPayDesignCardInfo($schema);
        $this->createPlgPayDesignCardOrder($schema);
        $this->createPlgPayDesignPeriodicInfo($schema);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema) {

        // dtb_paymentは受注データと紐付いているため削除しない
        $this->deleteFromDtbPayment();
        // プラグインで作成したページは削除する
        $this->deletePageLayout();

        // this down() migration is auto-generated, please modify it to your needs
        $schema->dropTable('plg_paydesign_plugin');
        $schema->dropTable('plg_paydesign_payment_method');
        $schema->dropTable('plg_paydesign_product_periodic_info');
        $schema->dropTable('plg_paydesign_order_info');
        $schema->dropTable('plg_paydesign_card_info');
        $schema->dropTable('plg_paydesign_card_order');
        $schema->dropTable('plg_paydesign_periodic_info');
    }

    /**
     * @param Schema $schema
     */
    public function postUp(Schema $schema) {

        $app = new \Eccube\Application();
        $app->boot();

        // Insert module information into plg_paydesign_plugin
        $pluginCode = 'PayDesign';
        $pluginName = 'ペイデザイン決済サービス';
        $datetime   = date('Y-m-d H:i:s');
        $insert     = "INSERT INTO plg_paydesign_plugin(
                                   plugin_code, plugin_name, create_date, update_date)
                       VALUES ('$pluginCode', '$pluginName', '$datetime', '$datetime'
                                                        );";
        $this->connection->executeUpdate($insert);
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignPlugin(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_plugin");

        $table->addColumn('plugin_id', 'integer', array(
            'autoincrement' => true,
        ));

        $table->addColumn('plugin_code', 'text', array(
            'notnull' => true,
        ));

        $table->addColumn('plugin_name', 'text', array(
            'notnull' => true,
        ));

        $table->addColumn('sub_data', 'text', array(
            'notnull' => false,
        ));

        $table->addColumn('auto_update_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        $table->setPrimaryKey(array('plugin_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignPaymentMethod(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_payment_method");

        //id
        $table->addColumn('payment_id', 'integer', array(
            'notnull' => true,
        ));

        // method
        $table->addColumn('payment_method', 'text', array(
            'notnull' => true,
        ));

        // delete flg
        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // create date
        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // update date
        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        $table->addColumn('memo01', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo02', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo03', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo04', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo05', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo06', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo07', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo08', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo09', 'text', array(
            'notnull' => false,
        ));
        $table->addColumn('memo10', 'text', array(
            'notnull' => false,
        ));

        // plugin_code
        $table->addColumn('plugin_code', 'text', array(
            'notnull' => false,
        ));

        $table->setPrimaryKey(array('payment_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignProductPeriodicInfo(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_product_periodic_info");

        //id
        $table->addColumn('product_class_id', 'integer', array(
            'notnull' => true,
        ));

        // product_id
        $table->addColumn('product_id', 'integer', array(
            'notnull' => true,
        ));

        // periodic flg
        $table->addColumn('periodic_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // periodic price
        $table->addColumn('periodic_price', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // periodic interval
        $table->addColumn('periodic_interval', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 1,
        ));

        // periodic cutoff day
        $table->addColumn('periodic_cutoff_day', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // periodic create day
        $table->addColumn('periodic_create_day', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // periodic settle method
        $table->addColumn('periodic_settle_method', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 1,
        ));

        // create date
        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // update date
        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // delete flg
        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->setPrimaryKey(array('product_class_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignOrderInfo(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_order_info");

        //id
        $table->addColumn('order_info_id', 'integer', array(
            'notnull' => true,
            'autoincrement' => true,
        ));

        // order id
        $table->addColumn('order_id', 'integer', array(
            'notnull' => true,
        ));

        // sid
        $table->addColumn('sid', 'text', array(
            'notnull' => true,
        ));

        // order kind
        $table->addColumn('order_kind', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // credit uid card select flg
        $table->addColumn('credit_uid_card_select_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // select convenience kind
        $table->addColumn('select_convenience_kind', 'smallint', array(
            'notnull' => false,
        ));

        // check count
        $table->addColumn('check_count', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // result seq
        $table->addColumn('result_seq', 'integer', array(
            'notnull' => false,
        ));

        // result date
        $table->addColumn('result_date', 'integer', array(
            'notnull' => false,
        ));

        // result time
        $table->addColumn('result_time', 'integer', array(
            'notnull' => false,
        ));

        // result ip
        $table->addColumn('result_ip', 'integer', array(
            'notnull' => false,
        ));

        // result kingaku
        $table->addColumn('result_kingaku', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // result cvs
        $table->addColumn('result_cvs', 'text', array(
            'notnull' => false,
        ));

        // result scode
        $table->addColumn('result_scode', 'text', array(
            'notnull' => false,
        ));

        // result shonin
        $table->addColumn('result_shonin', 'text', array(
            'notnull' => false,
        ));

        // result hishimuke
        $table->addColumn('result_hishimuke', 'text', array(
            'notnull' => false,
        ));

        // result fuka
        $table->addColumn('result_fuka', 'text', array(
            'notnull' => false,
        ));

        // result paymode
        $table->addColumn('result_paymode', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // result incount
        $table->addColumn('result_incount', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // result ip user id
        $table->addColumn('result_ip_user_id', 'text', array(
            'notnull' => false,
        ));

        // result conv payment info
        $table->addColumn('result_conv_payment_info', 'text', array(
            'notnull' => false,
        ));

        // result conv payment limit
        $table->addColumn('result_conv_payment_limit', 'text', array(
            'notnull' => false,
        ));

        // result conv confirm url
        $table->addColumn('result_conv_confirm_url', 'text', array(
            'notnull' => false,
        ));

        // result receive date
        $table->addColumn('result_receive_date', 'datetime', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        $table->setPrimaryKey(array('order_info_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignCardInfo(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_card_info");

        //id
        $table->addColumn('card_id', 'integer', array(
            'autoincrement' => true,
        ));

        // card sid
        $table->addColumn('card_sid', 'text', array(
            'notnull' => false,
        ));

        // customer id
        $table->addColumn('customer_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card kind
        $table->addColumn('card_kind', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card num
        $table->addColumn('card_num', 'text', array(
            'notnull' => false,
        ));

        // card limit
        $table->addColumn('card_limit', 'text', array(
            'notnull' => false,
        ));

        // card enable
        $table->addColumn('card_enable', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card order sid
        $table->addColumn('card_order_sid', 'text', array(
            'notnull' => false,
        ));

        // create date
        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // update date
        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // delete flg
        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->setPrimaryKey(array('card_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignCardOrder(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_card_order");

        //id
        $table->addColumn('card_order_id', 'integer', array(
            'autoincrement' => true,
        ));

        // card order sid
        $table->addColumn('card_order_sid', 'text', array(
            'notnull' => false,
        ));

        // customer id
        $table->addColumn('customer_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card kind
        $table->addColumn('card_kind', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card order status
        $table->addColumn('card_order_status', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // card ip user id
        $table->addColumn('card_ip_user_id', 'text', array(
            'notnull' => false,
        ));

        // create date
        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // update date
        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // delete flg
        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->setPrimaryKey(array('card_order_id'));
    }

    /**
     * @param Schema $schema
     */
    protected function createPlgPayDesignPeriodicInfo(Schema $schema) {

        $table = $schema->createTable("plg_paydesign_periodic_info");

        //id
        $table->addColumn('periodic_id', 'integer', array(
            'autoincrement' => true,
        ));

        // periodic status
        $table->addColumn('periodic_status', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 1,
        ));

        // periodic next date
        $table->addColumn('periodic_next_date', 'datetime', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // periodic interval
        $table->addColumn('periodic_interval', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 1,
        ));

        // periodic create day
        $table->addColumn('periodic_create_day', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
            'default' => 1,
        ));

        // customer id
        $table->addColumn('customer_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // payment id
        $table->addColumn('payment_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // payment method
        $table->addColumn('payment_method', 'text', array(
            'notnull' => false,
        ));

        // device type id
        $table->addColumn('device_type_id', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // message
        $table->addColumn('message', 'text', array(
            'notnull' => false,
        ));

        // shipping country id
        $table->addColumn('shipping_country_id', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // shipping pref
        $table->addColumn('shipping_pref', 'smallint', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // shipping name01
        $table->addColumn('shipping_name01', 'text', array(
            'notnull' => false,
        ));

        // shipping name02
        $table->addColumn('shipping_name02', 'text', array(
            'notnull' => false,
        ));

        // shipping kana01
        $table->addColumn('shipping_kana01', 'text', array(
            'notnull' => false,
        ));

        // shipping kana02
        $table->addColumn('shipping_kana02', 'text', array(
            'notnull' => false,
        ));

        // shipping company name
        $table->addColumn('shipping_company_name', 'text', array(
            'notnull' => false,
        ));

        // shipping tel01
        $table->addColumn('shipping_tel01', 'text', array(
            'notnull' => false,
        ));

        // shipping tel02
        $table->addColumn('shipping_tel02', 'text', array(
            'notnull' => false,
        ));

        // shipping tel03
        $table->addColumn('shipping_tel03', 'text', array(
            'notnull' => false,
        ));

        // shipping fax01
        $table->addColumn('shipping_fax01', 'text', array(
            'notnull' => false,
        ));

        // shipping fax02
        $table->addColumn('shipping_fax02', 'text', array(
            'notnull' => false,
        ));

        // shipping fax03
        $table->addColumn('shipping_fax03', 'text', array(
            'notnull' => false,
        ));

        // shipping zip01
        $table->addColumn('shipping_zip01', 'text', array(
            'notnull' => false,
        ));

        // shipping zip02
        $table->addColumn('shipping_zip02', 'text', array(
            'notnull' => false,
        ));

        // shipping zipcode
        $table->addColumn('shipping_zipcode', 'text', array(
            'notnull' => false,
        ));

        // shipping addr01
        $table->addColumn('shipping_addr01', 'text', array(
            'notnull' => false,
        ));

        // shipping addr02
        $table->addColumn('shipping_addr02', 'text', array(
            'notnull' => false,
        ));

        // shipping delivery name
        $table->addColumn('shipping_delivery_name', 'text', array(
            'notnull' => false,
        ));

        // shipping delivery time
        $table->addColumn('shipping_delivery_time', 'text', array(
            'notnull' => false,
        ));

        // delivery id
        $table->addColumn('delivery_id', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // time id
        $table->addColumn('time_id', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // fee id
        $table->addColumn('fee_id', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // subtotal
        $table->addColumn('subtotal', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // discount
        $table->addColumn('discount', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        // delivery_fee_total
        $table->addColumn('delivery_fee_total', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // charge
        $table->addColumn('charge', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // tax
        $table->addColumn('tax', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // total
        $table->addColumn('total', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // payment_total
        $table->addColumn('payment_total', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // product id
        $table->addColumn('product_id', 'integer', array(
            'unsigned' => false,
        ));

        // product class id
        $table->addColumn('product_class_id', 'integer', array(
            'unsigned' => false,
        ));

        // product name
        $table->addColumn('product_name', 'text', array(
            'notnull' => true,
        ));

        // product code
        $table->addColumn('product_code', 'text', array(
            'notnull' => false,
        ));

        // class_name1
        $table->addColumn('class_name1', 'text', array(
            'notnull' => false,
        ));

        // class_name2
        $table->addColumn('class_name2', 'text', array(
            'notnull' => false,
        ));

        // class_category_name1
        $table->addColumn('class_category_name1', 'text', array(
            'notnull' => false,
        ));

        // class_category_name2
        $table->addColumn('class_category_name2', 'text', array(
            'notnull' => false,
        ));

        // price
        $table->addColumn('price', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // quantity
        $table->addColumn('quantity', 'integer', array(
            'notnull' => false,
            'unsigned' => false,
        ));

        // note
        $table->addColumn('note', 'text', array(
            'notnull' => false,
        ));

        // base order id
        $table->addColumn('base_order_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // base shipping id
        $table->addColumn('base_shipping_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // base item id
        $table->addColumn('base_item_id', 'integer', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // create date
        $table->addColumn('create_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // update date
        $table->addColumn('update_date', 'datetime', array(
            'notnull' => true,
            'unsigned' => false,
        ));

        // delete flg
        $table->addColumn('del_flg', 'smallint', array(
            'notnull' => true,
            'unsigned' => false,
            'default' => 0,
        ));

        $table->setPrimaryKey(array('periodic_id'));
    }

    protected function deleteFromDtbPayment()
    {
        // plg_paydesign_payment_method より payment_id を取得
        $select = "SELECT p.payment_id FROM plg_paydesign_payment_method as pd
                JOIN dtb_payment as p ON pd.payment_id = p.payment_id
                WHERE pd.plugin_code =  'PayDesign'";

        $paymentIds = $this->connection->executeQuery($select)->fetchAll();
        $ids = array();
        foreach ($paymentIds as $item){
            $ids[]=$item['payment_id'];
        }

        // 対象の payment_id の dtb_payment のデータの del_flg を設定する( = dtb_payment からの削除 )
        if (!empty($ids)){
            $param = implode(",", $ids);
            $update = "UPDATE dtb_payment SET del_flg = 1 WHERE payment_id in ($param)";
            $this->connection->executeUpdate($update);
        }
    }

    protected function deletePageLayout()
    {
        /*
         * 現状コメントアウトしておき、対象ページが出来てから実装する
         * 削除するデータが増える場合は、URL部分をORで増やす
         *
         */
        $sql_delete  = " DELETE FROM dtb_page_layout WHERE";
        $sql_delete .= " url = 'paydesign_shopping_convenience' OR";
        $sql_delete .= " url = 'paydesign_shopping_convenience_complete' OR";
        $sql_delete .= " url = 'paydesign_mypage_credit' OR";
        $sql_delete .= " url = 'paydesign_mypage_credit_complete' OR";
        $sql_delete .= " url = 'paydesign_mypage_credit_delete_complete' OR";
        $sql_delete .= " url = 'paydesign_mypage_periodic' OR";
        $sql_delete .= " url = 'paydesign_mypage_periodic_edit' OR";
        $sql_delete .= " url = 'paydesign_mypage_periodic_complete' OR";
        $sql_delete .= " url = 'shopping_confirm'";
        $this->connection->executeUpdate($sql_delete);
    }
}

?>
